#region License Information
/* HeuristicLab
 * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HEAL.Attic;

namespace HeuristicLab.Common {
  [StorableType("54fef53f-3ccc-4493-8973-a8bbdad32ba2")]
  public interface IDeepCloneable : ICloneable {
    /// <summary>
    /// Creates a deep clone of this instance.
    /// </summary>
    /// <param name="cloner">The cloner which is responsible for keeping track of all already
    /// cloned objects.</param>
    /// <returns>A clone of this instance.</returns>
    IDeepCloneable Clone(Cloner cloner);
  }
}
